#include "project.h"
#include <stddef.h>
#include <string.h>
#include "WIDGET.h"
#include "WM.h"
#include "BUTTON.h"
#include "DIALOG.h"
#include "FS.h"
#include "GUI.h"



/*********************************************************************
*
*       Defines
*
**********************************************************************
*/

/*********************************************************************
*
*       APP_GetData
*/
int APP_GetDataBMP(void * p, const U8 ** ppData, unsigned NumBytes, U32 Off) 
{
    static U8   acBuffer[1024];

    FS_FILE   * pFile;
    int         NumBytesRead;

    pFile = (FS_FILE *)p;
    //
    // Check buffer size
    //
    if (NumBytes > sizeof(acBuffer)) 
    {
        NumBytes = sizeof(acBuffer);
        
    }
    //
    // Set file pointer to the required position
    //
    FS_SetFilePos(pFile, Off, FS_FILE_BEGIN);
    //
    // Read data into buffer
    //
    NumBytesRead = FS_FRead(acBuffer, 1, NumBytes, pFile);
    //
    // Set data pointer to the beginning of the buffer
    //
    *ppData = (const U8 *)acBuffer;
    //
    // Return number of available bytes
    //
    return NumBytesRead;

}


/*********************************************************************
*
*       MainTask
*/
void DrawBMPExternalMemory(const char * filename) 
{
    FS_FILE * pFile;
    char      acVolumeName[10];

    //
    // Mount volume
    //
    FS_GetVolumeName(0, acVolumeName, sizeof(acVolumeName));
    
    if (FS_Mount(acVolumeName) > 0) 
    {
        //
        // Open file
        //
        pFile = FS_FOpen(filename, "rb");
        
    }
    //
    // Draw the bmp image by passing a pointer to the file handle and the GetData function
    //   
    GUI_BMP_DrawEx(APP_GetDataBMP, pFile,0, 0);
    //
    // Close file
    //
    FS_FClose(pFile);

}
