/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH                         *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.48                          *
*        Compiled Jun 13 2018, 10:51:02                              *
*        (c) 2018 Segger Microcontroller GmbH                        *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
// USER END
#include "project.h"
#include <stddef.h>
#include <string.h>
#include "WIDGET.h"
#include "WM.h"
#include "BUTTON.h"
#include "DIALOG.h"
#include "FS.h"


#define RECOMMENDED_MEMORY (1024L * 5)
/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0             (GUI_ID_USER + 0x00)
#define ID_HEADER_0             (GUI_ID_USER + 0x01)

extern void DrawBMPExternalMemory();
extern void CreateToolsScreen1();
extern void MainScreen();


/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = 
{
  { WINDOW_CreateIndirect, "Tools", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Oxygen Calibration", GUI_ID_BUTTON0, 25, 40, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Touchscreen Calibration", GUI_ID_BUTTON1, 25, 90, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "LCD Test", GUI_ID_BUTTON2, 25, 140, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Back", GUI_ID_BUTTON3, 15, 205,  80,  25, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Home", GUI_ID_BUTTON4, 120, 205,  80,  25, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Next", GUI_ID_BUTTON5, 225, 205,  80,  25, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_O2Cell", GUI_ID_IMAGE0, 255, 40, 46, 35, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_Touchscreen", GUI_ID_IMAGE1, 255, 90, 46, 35, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_LCDtest", GUI_ID_IMAGE2, 255, 140, 46, 35, 0, 0x0, 0},

};
/*********************************************************************
*        Button Callback 80 X 25
**********************************************************************/
static void _cbButton80x25(WM_MESSAGE * pMsg) 
{

    switch (pMsg->MsgId) 
    {
        GUI_RECT Rect;
        char ac[50];
        
        case WM_PAINT:

            //
            // Receive the client area.
            //
            WM_GetClientRect(&Rect);
            //
            // Check the button state, pMsg->hWin is the handle of the button, and use it as an index.
            //
            if(BUTTON_IsPressed(pMsg->hWin))
            {
                DrawBMPExternalMemory("ButtonDown80x25.bmp");
            }
            else
            {
                DrawBMPExternalMemory("ButtonUp80x25.bmp");
            }
            //
            // Set text mode and color
            //
            GUI_SetTextMode(GUI_TM_TRANS);
            GUI_SetColor(GUI_WHITE);
            GUI_SetFont(GUI_FONT_16B_1);
            BUTTON_GetText(pMsg->hWin, ac, sizeof(ac));
            //
            // Draw a text.
            //
            GUI_DispStringInRect(ac, &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);         

        break;
        default:
            BUTTON_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*        Button Callback
**********************************************************************/
static void _cbButton185x35(WM_MESSAGE * pMsg) 
{

    switch (pMsg->MsgId) 
    {
        GUI_RECT Rect;
        char ac[50];
        
        case WM_PAINT:

            //
            // Receive the client area.
            //
            WM_GetClientRect(&Rect);
            //
            // Check the button state, pMsg->hWin is the handle of the button, and use it as an index.
            //
            if(BUTTON_IsPressed(pMsg->hWin))
            {
                DrawBMPExternalMemory("ButtonDown185x35.bmp");
            }
            else
            {
                DrawBMPExternalMemory("ButtonUp185x35.bmp");
            }
            //
            // Set text mode and color
            //
            GUI_SetTextMode(GUI_TM_TRANS);
            GUI_SetColor(GUI_WHITE);
            GUI_SetFont(GUI_FONT_16B_1);
            BUTTON_GetText(pMsg->hWin, ac, sizeof(ac));
            //
            // Draw a text.
            //
            GUI_DispStringInRect(ac, &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);         

        break;
        default:
            BUTTON_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       O2 Cell Image Callback
**********************************************************************/
static void _cbO2CellImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("O2Cell.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       Touch Calibration Image Callback
**********************************************************************/
static void _cbTouchCalibrationImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("TouchScreen.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       LCD TestImage Callback
**********************************************************************/
static void _cbLCDTestImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("DiagnosticsLCD.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}


static void _cbToolsScreen(WM_MESSAGE * pMsg) 
{
    int     NCode;
    int     Id;
    WM_HWIN hDlg;
    BUTTON_Handle hButton;
    IMAGE_Handle hImage;

    hDlg = pMsg ->hWin;
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            //
            // Draw the background. This is quite important because otherwise we would still see the child window although it gets deleted.
            // With this drawing the background wouldn't "know" how to draw itself.
            //
            GUI_SetBkColor(GUI_BEIGE_BACKGROUND);
            GUI_Clear();

        break;
            
        case WM_INIT_DIALOG:
            
            
            hButton = HEADER_CreateEx(100, 0, 100, 40, pMsg->hWin, WM_CF_SHOW, 0, ID_HEADER_0);
            HEADER_SetFont(hButton, GUI_FONT_20B_1);
            HEADER_SetTextColor(hButton, GUI_BLACK);
            HEADER_AddItem(hButton, 100, "TOOLS", GUI_TA_CENTER);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON0); // Initialization of 'O2Ccalibration Button'
            WM_SetCallback(hButton, _cbButton185x35);

            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON1);// Initialization of 'Touchscreen Calibration Button'            
            WM_SetCallback(hButton, _cbButton185x35);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON2);// Initialization of 'LCD Test Button'          
            WM_SetCallback(hButton, _cbButton185x35);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON3);// Initialization of 'Back Button'                
            WM_SetCallback(hButton, _cbButton80x25);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON4);// Initialization of 'Home Button'           
            WM_SetCallback(hButton, _cbButton80x25);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON5);// Initialization of 'Next Button'            
            WM_SetCallback(hButton, _cbButton80x25);            

            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE0);// Initialization of 'O2 Cell Image'
            WM_SetCallback(hImage, _cbO2CellImage);
            
            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE1);// Initialization of 'Touchscreen Calibration Image'
            WM_SetCallback(hImage, _cbTouchCalibrationImage); 
            
            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE2);// Initialization of 'LCD Test Image'
            WM_SetCallback(hImage, _cbLCDTestImage);            
            
        break;    
   
        case WM_NOTIFY_PARENT:
            Id   = WM_GetId(pMsg->hWinSrc);
            NCode = pMsg->Data.v;
            switch (NCode) 
            { 
                case WM_NOTIFICATION_RELEASED:
                
                    if(Id == GUI_ID_BUTTON0) // 'O2Ccalibration Button'
                    {                        
//                        WM_CreateWindowAsChild(0, 0, 320, 240, WM_HBKWIN, WM_CF_SHOW, _cbO2Cell, 0);
                        
                    }
                    
                    if(Id == GUI_ID_BUTTON1) //'Touchscreen Calibration Button'
                    {
                        
//                        WM_CreateWindowAsChild(0, 0, 320, 240, WM_HBKWIN, WM_CF_SHOW, _cbO2Cell, 0);
                        
                    }

                    if(Id == GUI_ID_BUTTON2) //'LCD Test Button'
                    {
//                        WM_CreateWindowAsChild(0, 0, 320, 240, WM_HBKWIN, WM_CF_SHOW, _cbO2Cell, 0);
                        
                    } 
                    
                    if(Id == GUI_ID_BUTTON3) //'Back Button' 
                    {

                        
                    }                    
                    
                    if(Id == GUI_ID_BUTTON4)
                    {
                        GUI_EndDialog(hDlg,1);
                        MainScreen();//'Home Button'
                        
                    }
                    
                    if(Id == GUI_ID_BUTTON5) //'Next Button' 
                    {
                        GUI_EndDialog(hDlg,1);
                        CreateToolsScreen1();
                        
                    }
                    
//                    else 
//                    {
//                        _Pressed = 0;
//                        WM_InvalidateWindow(pMsg->hWin);
//                    }
            }            

        break;
            // USER START (Optionally insert additional message handling)
            // USER END
    default:
    WM_DefaultProc(pMsg);
    break;
    }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindow
*/
void CreateToolsScreen(void) 
{
  //
  // Check if recommended memory for the sample is available
  //
  if (GUI_ALLOC_GetNumFreeBytes() < RECOMMENDED_MEMORY) {
    GUI_ErrorOut("Not enough memory available."); 
    return;
  }    
    //
    // Use memory devices for all windows
    //
    #if GUI_SUPPORT_MEMDEV     
        WM_SetCreateFlags(WM_CF_MEMDEV);
        WM_EnableMemdev(WM_HBKWIN);
    #endif

    WM_SetDesktopColor(GUI_BLACK);
    while(1) 
    {
        GUI_ExecDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), &_cbToolsScreen, 0, 0, 0);
        GUI_Delay(1);
    }
}   
/*************************** End of file ****************************/
