/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH                         *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.48                          *
*        Compiled Jun 13 2018, 10:51:02                              *
*        (c) 2018 Segger Microcontroller GmbH                        *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
// USER END
#include "project.h"
#include <stddef.h>
#include <string.h>
#include "WIDGET.h"
#include "WM.h"
#include "BUTTON.h"
#include "DIALOG.h"
#include "FS.h"

#define RECOMMENDED_MEMORY (1024L * 5)
/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0             (GUI_ID_USER + 0x00)
#define ID_HEADER_0             (GUI_ID_USER + 0x01)



// USER START (Optionally insert additional defines)
extern void DrawBMPExternalMemory();
extern void MainScreen(void);
extern void CreateToolsScreen(void);
extern void CreateToolsScreen2(void);


// USER END


/*********************************************************************
*
*       _aDialogCreate
*/


static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = 
{
  { WINDOW_CreateIndirect, "Tools", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Alarm Test", GUI_ID_BUTTON0, 25, 40, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Bleed Valve Test", GUI_ID_BUTTON1, 25, 90, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "System Language", GUI_ID_BUTTON2, 25, 140, 185, 35, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Back", GUI_ID_BUTTON3, 15, 205,  80,  25, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Home", GUI_ID_BUTTON4, 120, 205,  80,  25, 0, 0x0, 0},
  { BUTTON_CreateIndirect, "Next", GUI_ID_BUTTON5, 225, 205,  80,  25, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_Alarm", GUI_ID_IMAGE0, 255, 40, 46, 35, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_BleedValve", GUI_ID_IMAGE1, 255, 90, 46, 35, 0, 0x0, 0},
  { IMAGE_CreateIndirect, "Image_Language", GUI_ID_IMAGE2, 255, 140, 46, 35, 0, 0x0, 0},
  // USER START (Optionally insert additional widgets)
  // USER END
};
/*********************************************************************
*        Button Callback 80 X 25
**********************************************************************/
static void _cbButton80x25(WM_MESSAGE * pMsg) 
{

    switch (pMsg->MsgId) 
    {
        GUI_RECT Rect;
        char ac[50];
        
        case WM_PAINT:

            //
            // Receive the client area.
            //
            WM_GetClientRect(&Rect);
            //
            // Check the button state, pMsg->hWin is the handle of the button, and use it as an index.
            //
            if(BUTTON_IsPressed(pMsg->hWin))
            {
                DrawBMPExternalMemory("ButtonDown80x25.bmp");
            }
            else
            {
                DrawBMPExternalMemory("ButtonUp80x25.bmp");
            }
            //
            // Set text mode and color
            //
            GUI_SetTextMode(GUI_TM_TRANS);
            GUI_SetColor(GUI_WHITE);
            GUI_SetFont(GUI_FONT_16B_1);
            BUTTON_GetText(pMsg->hWin, ac, sizeof(ac));
            //
            // Draw a text.
            //
            GUI_DispStringInRect(ac, &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);         

        break;
        default:
            BUTTON_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*        Button Callback
**********************************************************************/
static void _cbButton185x35(WM_MESSAGE * pMsg) 
{

    switch (pMsg->MsgId) 
    {
        GUI_RECT Rect;
        char ac[50];
        
        case WM_PAINT:

            //
            // Receive the client area.
            //
            WM_GetClientRect(&Rect);
            //
            // Check the button state, pMsg->hWin is the handle of the button, and use it as an index.
            //
            if(BUTTON_IsPressed(pMsg->hWin))
            {
                DrawBMPExternalMemory("ButtonDown185x35.bmp");
            }
            else
            {
                DrawBMPExternalMemory("ButtonUp185x35.bmp");
            }
            //
            // Set text mode and color
            //
            GUI_SetTextMode(GUI_TM_TRANS);
            GUI_SetColor(GUI_WHITE);
            GUI_SetFont(GUI_FONT_16B_1);
            BUTTON_GetText(pMsg->hWin, ac, sizeof(ac));
            //
            // Draw a text.
            //
            GUI_DispStringInRect(ac, &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);         

        break;
        default:
            BUTTON_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       Alarm Test Image Callback
**********************************************************************/
static void _cbAlarmTestImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("AlarmAudio.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       Bleed Valve Test Image Callback
**********************************************************************/
static void _cbBleedValveTestImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("BleedValveTest.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       System Language Image Callback
**********************************************************************/
static void _cbSystemLanguageImage(WM_MESSAGE * pMsg) 
{
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            DrawBMPExternalMemory("SystemLanguage.bmp");
        break;
        default:
            IMAGE_Callback(pMsg); // The original callback
        break;
    }
 
}
/*********************************************************************
*       O2 calibration window Callback
**********************************************************************/
//static void _cbO2Cell(WM_MESSAGE * pMsg) 
//{
//    switch (pMsg->MsgId) 
//    {
//        case WM_PAINT:
//            GUI_SetBkColor(GUI_WHITE);
//            GUI_Clear();
//        break;
//        default:
//            BUTTON_Callback(pMsg); // The original callback
//        break;
//    }
// 
//}


static void _cbToolsScreen1(WM_MESSAGE * pMsg) 
{
    int     NCode;
    int     Id;
    WM_HWIN hDlg;
    BUTTON_Handle hButton;
    IMAGE_Handle hImage;

    hDlg = pMsg ->hWin;
    switch (pMsg->MsgId) 
    {
        case WM_PAINT:
            //
            // Draw the background. This is quite important because otherwise we would still see the child window although it gets deleted.
            // With this drawing the background wouldn't "know" how to draw itself.
            //
            GUI_SetBkColor(GUI_BEIGE_BACKGROUND);
            GUI_Clear();

        break;
            
        case WM_INIT_DIALOG:
            
            
            hButton = HEADER_CreateEx(100, 0, 100, 40, pMsg->hWin, WM_CF_SHOW, 0, ID_HEADER_0);
            HEADER_SetFont(hButton, GUI_FONT_20B_1);
            HEADER_SetTextColor(hButton, GUI_BLACK);
            HEADER_AddItem(hButton, 100, "TOOLS", GUI_TA_CENTER);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON0); // Initialization of 'Alarm Test Image Button'
            WM_SetCallback(hButton, _cbButton185x35);

            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON1);// Initialization of ' Bleed Valve Test Button'            
            WM_SetCallback(hButton, _cbButton185x35);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON2);// Initialization of 'System Language Button'          
            WM_SetCallback(hButton, _cbButton185x35);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON3);// Initialization of 'Back Button'                
            WM_SetCallback(hButton, _cbButton80x25);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON4);// Initialization of 'Home Button'           
            WM_SetCallback(hButton, _cbButton80x25);
            
            hButton = WM_GetDialogItem(pMsg->hWin, GUI_ID_BUTTON5);// Initialization of 'Next Button'            
            WM_SetCallback(hButton, _cbButton80x25);            

            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE0);// Initialization of 'O2 Cell Image'
            WM_SetCallback(hImage, _cbAlarmTestImage);
            
            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE1);// Initialization of 'Touchscreen Calibration Image'
            WM_SetCallback(hImage, _cbBleedValveTestImage); 
            
            hImage = WM_GetDialogItem(pMsg->hWin, GUI_ID_IMAGE2);// Initialization of 'LCD Test Image'
            WM_SetCallback(hImage, _cbSystemLanguageImage);            
            
        break;    
   
        case WM_NOTIFY_PARENT:
            Id   = WM_GetId(pMsg->hWinSrc);
            NCode = pMsg->Data.v;
            switch (NCode) 
            { 
                case WM_NOTIFICATION_RELEASED:
                
                    if(Id == GUI_ID_BUTTON0) //'Alarm Test Image Button'
                    {                        
//                        WM_CreateWindowAsChild(0, 0, 320, 240, WM_HBKWIN, WM_CF_SHOW, _cbO2Cell, 0);
                        
                    }
                    
                    if(Id == GUI_ID_BUTTON1) //'Bleed Valve Test Button' 
                    {
                        
//                        WM_CreateWindowAsChild(0, 0, 320, 240, WM_HBKWIN, WM_CF_SHOW, _cbO2Cell, 0);
                        
                    }

                    if(Id == GUI_ID_BUTTON3) //'Back Button' 
                    {
                        GUI_EndDialog(hDlg,1);
                        CreateToolsScreen();

                        
                    }                    
                    
                    if(Id == GUI_ID_BUTTON4) //'Home Button'
                    {
                        GUI_EndDialog(hDlg,1);
                        MainScreen();
                        
                    }
                    
                    if(Id == GUI_ID_BUTTON5) //'Next Button' 
                    {
                        GUI_EndDialog(hDlg,1);
                        CreateToolsScreen2();
                        
                    }
            }            
        break;

    default:
    WM_DefaultProc(pMsg);
    break;
    }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindow
*/
void CreateToolsScreen1(void) 
{
  if (GUI_ALLOC_GetNumFreeBytes() < RECOMMENDED_MEMORY) {
    GUI_ErrorOut("Not enough memory available."); 
    return;
  } 
    //
    // Use memory devices for all windows
    //
    #if GUI_SUPPORT_MEMDEV     
        WM_SetCreateFlags(WM_CF_MEMDEV);
        WM_EnableMemdev(WM_HBKWIN);
    #endif

    WM_SetDesktopColor(GUI_BLACK);
    while(1) 
    {
        GUI_ExecDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), &_cbToolsScreen1, 0, 0, 0);
        GUI_Delay(1);
    }
}   
/*************************** End of file ****************************/
